/*
 * Page mark ring for xdvi
 *
 * Copyright (c) 1993, 1995
 *      ONO Kouichi             onono@fuka.info.waseda.ac.jp
 * All rights reserved.
 */

#ifndef _MARKPAGE_H_
#define _MARKPAGE_H_

#include "chardef.h"
#include "markring.h"

#define STRLENGTH       (1024)

typedef int     PAGE;

extern  void    CreateNewPageMarkRing(void);
extern  void    MakePageMarkRingNull(void);
extern  BOOL    ThisPageIsMarked(PAGE);
extern  void    MarkPage(PAGE);
extern  void    UnmarkPage(PAGE);
extern  void    ReverseTheMarkOfPage(PAGE);
extern  BOOL    EmptyPageMarkRing(void);
extern  PAGE    LastMarkPage(void);
extern  void    SetPageMarkAtLast(PAGE);
extern  void    RotatePageMarkRing(void);
#ifndef DVISEL
extern  LIST_LOCATION   MakeMarkedPageList(PAGE *);
extern  LIST_LOCATION   MakeSortedMarkedPageList(PAGE *);
extern  void    GetMarkedPageListAsString(char *, char, char, char);
extern  void    GetSortedMarkedPageListAsString(char *, char, char, char);
extern  void    GetSortedMarkedPPListAsString(char *, char, char, char, char);
#endif /* DVISEL */

#define DEFAULTTOCHAR   CHAR_COLON

#endif  /* _MARKPAGE_H_ */
